import { useState } from 'react'
import reactLogo from './assets/image/react.svg'
import './assets/js/file-upload.js'

function FileUploadApp() {
  const [fileProperties, setFileProperties] = useState({
    file: null,
    fileType: null,
    fileName: null,
  });
  const [isUploadAction, setUploadAction] = useState(false);

  const setFileProperty = (file, fileType, fileName) => {
    setFileProperties({ file, fileType, fileName });
  };

  const clearFileProperty = () => {
    setFileProperties({ file: null, fileType: null, fileName: null });
  };

  const handleFileChange = (event) => {
    const selectedFile = event.target.files[0];
    if (selectedFile) {
      setFileProperty(selectedFile, selectedFile.type, selectedFile.name);
    } else {
      clearFileProperty();
    }
  };

  const handleUpload = (event) => {
    event.preventDefault();
    setUploadAction(true);
    displayFilePreview(fileProperties.fileType, fileProperties.file, fileProperties.fileName);
    uploadFile(fileProperties.file);
  };

  return (
    <>
    <div><img src={reactLogo} className="logo" /></div>
      <form onSubmit={handleUpload}>
            <div id="error-message"></div>
            <input
              type="file"
              accept=".png, .jpg, .jpeg, .gif, .pdf, .docx"
              onChange={handleFileChange}
              required
            />
            <button type="submit">Upload</button>
          </form>
          
          {isUploadAction && fileProperties.fileType && (
            <div className="file-details">
              <h3>Preview :</h3>
              {fileProperties.fileName && <p>File Name: {fileProperties.fileName}</p>}
            </div>
          )}
          <div id="file-preview"></div>
    </>
  )
}

export default FileUploadApp